diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/aodv/bindings/modulegen__gcc_LP64.py ns-3.32/src/aodv/bindings/modulegen__gcc_LP64.py
--- ns-3.31/src/aodv/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/aodv/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
@@ -8181,7 +8281,7 @@
     cls.add_method('PrintRoutingTable', 
                    'void', 
                    [param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream'), param('ns3::Time::Unit', 'unit', default_value='::ns3::Time::Unit::S')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-routing-protocol.h (module 'aodv'): bool ns3::aodv::RoutingProtocol::RouteInput(ns3::Ptr<const ns3::Packet> p, ns3::Ipv4Header const & header, ns3::Ptr<const ns3::NetDevice> idev, ns3::Ipv4RoutingProtocol::UnicastForwardCallback ucb, ns3::Ipv4RoutingProtocol::MulticastForwardCallback mcb, ns3::Ipv4RoutingProtocol::LocalDeliverCallback lcb, ns3::Ipv4RoutingProtocol::ErrorCallback ecb) [member function]
     cls.add_method('RouteInput', 
                    'bool', 
@@ -8227,7 +8327,7 @@
     cls.add_method('DoInitialize', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='protected')
+                   visibility='protected', is_virtual=True)
     return
 
 def register_Ns3AodvRoutingTable_methods(root_module, cls):
@@ -8276,10 +8376,10 @@
     cls.add_method('MarkLinkAsUnidirectional', 
                    'bool', 
                    [param('ns3::Ipv4Address', 'neighbor'), param('ns3::Time', 'blacklistTimeout')])
-    ## aodv-rtable.h (module 'aodv'): void ns3::aodv::RoutingTable::Print(ns3::Ptr<ns3::OutputStreamWrapper> stream) const [member function]
+    ## aodv-rtable.h (module 'aodv'): void ns3::aodv::RoutingTable::Print(ns3::Ptr<ns3::OutputStreamWrapper> stream, ns3::Time::Unit unit=::ns3::Time::Unit::S) const [member function]
     cls.add_method('Print', 
                    'void', 
-                   [param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream')], 
+                   [param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream'), param('ns3::Time::Unit', 'unit', default_value='::ns3::Time::Unit::S')], 
                    is_const=True)
     ## aodv-rtable.h (module 'aodv'): void ns3::aodv::RoutingTable::Purge() [member function]
     cls.add_method('Purge', 
@@ -8403,10 +8503,10 @@
     cls.add_method('LookupPrecursor', 
                    'bool', 
                    [param('ns3::Ipv4Address', 'id')])
-    ## aodv-rtable.h (module 'aodv'): void ns3::aodv::RoutingTableEntry::Print(ns3::Ptr<ns3::OutputStreamWrapper> stream) const [member function]
+    ## aodv-rtable.h (module 'aodv'): void ns3::aodv::RoutingTableEntry::Print(ns3::Ptr<ns3::OutputStreamWrapper> stream, ns3::Time::Unit unit=::ns3::Time::Unit::S) const [member function]
     cls.add_method('Print', 
                    'void', 
-                   [param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream')], 
+                   [param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream'), param('ns3::Time::Unit', 'unit', default_value='::ns3::Time::Unit::S')], 
                    is_const=True)
     ## aodv-rtable.h (module 'aodv'): void ns3::aodv::RoutingTableEntry::SetBlacklistTimeout(ns3::Time t) [member function]
     cls.add_method('SetBlacklistTimeout', 
@@ -8476,12 +8576,12 @@
     cls.add_method('GetInstanceTypeId', 
                    'ns3::TypeId', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): uint32_t ns3::aodv::RrepAckHeader::GetSerializedSize() const [member function]
     cls.add_method('GetSerializedSize', 
                    'uint32_t', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): static ns3::TypeId ns3::aodv::RrepAckHeader::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
                    'ns3::TypeId', 
@@ -8491,12 +8591,12 @@
     cls.add_method('Print', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): void ns3::aodv::RrepAckHeader::Serialize(ns3::Buffer::Iterator start) const [member function]
     cls.add_method('Serialize', 
                    'void', 
                    [param('ns3::Buffer::Iterator', 'start')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     return
 
 def register_Ns3AodvRrepHeader_methods(root_module, cls):
@@ -8535,7 +8635,7 @@
     cls.add_method('GetInstanceTypeId', 
                    'ns3::TypeId', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): ns3::Time ns3::aodv::RrepHeader::GetLifeTime() const [member function]
     cls.add_method('GetLifeTime', 
                    'ns3::Time', 
@@ -8555,7 +8655,7 @@
     cls.add_method('GetSerializedSize', 
                    'uint32_t', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): static ns3::TypeId ns3::aodv::RrepHeader::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
                    'ns3::TypeId', 
@@ -8565,12 +8665,12 @@
     cls.add_method('Print', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): void ns3::aodv::RrepHeader::Serialize(ns3::Buffer::Iterator start) const [member function]
     cls.add_method('Serialize', 
                    'void', 
                    [param('ns3::Buffer::Iterator', 'start')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): void ns3::aodv::RrepHeader::SetAckRequired(bool f) [member function]
     cls.add_method('SetAckRequired', 
                    'void', 
@@ -8651,7 +8751,7 @@
     cls.add_method('GetInstanceTypeId', 
                    'ns3::TypeId', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): ns3::Ipv4Address ns3::aodv::RreqHeader::GetOrigin() const [member function]
     cls.add_method('GetOrigin', 
                    'ns3::Ipv4Address', 
@@ -8666,7 +8766,7 @@
     cls.add_method('GetSerializedSize', 
                    'uint32_t', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): static ns3::TypeId ns3::aodv::RreqHeader::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
                    'ns3::TypeId', 
@@ -8681,12 +8781,12 @@
     cls.add_method('Print', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): void ns3::aodv::RreqHeader::Serialize(ns3::Buffer::Iterator start) const [member function]
     cls.add_method('Serialize', 
                    'void', 
                    [param('ns3::Buffer::Iterator', 'start')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): void ns3::aodv::RreqHeader::SetDestinationOnly(bool f) [member function]
     cls.add_method('SetDestinationOnly', 
                    'void', 
@@ -8746,12 +8846,12 @@
     cls.add_method('GetInstanceTypeId', 
                    'ns3::TypeId', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): uint32_t ns3::aodv::TypeHeader::GetSerializedSize() const [member function]
     cls.add_method('GetSerializedSize', 
                    'uint32_t', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): static ns3::TypeId ns3::aodv::TypeHeader::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
                    'ns3::TypeId', 
@@ -8766,12 +8866,12 @@
     cls.add_method('Print', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## aodv-packet.h (module 'aodv'): void ns3::aodv::TypeHeader::Serialize(ns3::Buffer::Iterator start) const [member function]
     cls.add_method('Serialize', 
                    'void', 
                    [param('ns3::Buffer::Iterator', 'start')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     return
 
 def register_functions(root_module):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/aodv/model/aodv-routing-protocol.cc ns-3.32/src/aodv/model/aodv-routing-protocol.cc
--- ns-3.31/src/aodv/model/aodv-routing-protocol.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/aodv/model/aodv-routing-protocol.cc	2020-10-06 15:35:43.000000000 -0700
@@ -343,7 +343,7 @@
                         << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
                         << ", AODV Routing table" << std::endl;
 
-  m_routingTable.Print (stream);
+  m_routingTable.Print (stream, unit);
   *stream->GetStream () << std::endl;
 }
 
@@ -1106,7 +1106,7 @@
       retry = m_netTraversalTime * (1 << backoffFactor);
     }
   m_addressReqTimer[dst].Schedule (retry);
-  NS_LOG_LOGIC ("Scheduled RREQ retry in " << retry.GetSeconds () << " seconds");
+  NS_LOG_LOGIC ("Scheduled RREQ retry in " << retry.As (Time::S));
 }
 
 void
@@ -1959,8 +1959,8 @@
       // Just make sure that the RerrRateLimit timer is running and will expire
       NS_ASSERT (m_rerrRateLimitTimer.IsRunning ());
       // discard the packet and return
-      NS_LOG_LOGIC ("RerrRateLimit reached at " << Simulator::Now ().GetSeconds () << " with timer delay left "
-                                                << m_rerrRateLimitTimer.GetDelayLeft ().GetSeconds ()
+      NS_LOG_LOGIC ("RerrRateLimit reached at " << Simulator::Now ().As (Time::S) << " with timer delay left "
+                                                << m_rerrRateLimitTimer.GetDelayLeft ().As (Time::S)
                                                 << "; suppressing RERR");
       return;
     }
@@ -2021,8 +2021,8 @@
       // Just make sure that the RerrRateLimit timer is running and will expire
       NS_ASSERT (m_rerrRateLimitTimer.IsRunning ());
       // discard the packet and return
-      NS_LOG_LOGIC ("RerrRateLimit reached at " << Simulator::Now ().GetSeconds () << " with timer delay left "
-                                                << m_rerrRateLimitTimer.GetDelayLeft ().GetSeconds ()
+      NS_LOG_LOGIC ("RerrRateLimit reached at " << Simulator::Now ().As (Time::S) << " with timer delay left "
+                                                << m_rerrRateLimitTimer.GetDelayLeft ().As (Time::S)
                                                 << "; suppressing RERR");
       return;
     }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/aodv/model/aodv-rtable.cc ns-3.32/src/aodv/model/aodv-rtable.cc
--- ns-3.31/src/aodv/model/aodv-rtable.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/aodv/model/aodv-rtable.cc	2020-10-06 15:35:43.000000000 -0700
@@ -160,7 +160,7 @@
 void
 RoutingTableEntry::Invalidate (Time badLinkLifetime)
 {
-  NS_LOG_FUNCTION (this << badLinkLifetime.GetSeconds ());
+  NS_LOG_FUNCTION (this << badLinkLifetime.As (Time::S));
   if (m_flag == INVALID)
     {
       return;
@@ -171,7 +171,7 @@
 }
 
 void
-RoutingTableEntry::Print (Ptr<OutputStreamWrapper> stream) const
+RoutingTableEntry::Print (Ptr<OutputStreamWrapper> stream, Time::Unit unit /* = Time::S */) const
 {
   std::ostream* os = stream->GetStream ();
   *os << m_ipv4Route->GetDestination () << "\t" << m_ipv4Route->GetGateway ()
@@ -197,7 +197,7 @@
   *os << "\t";
   *os << std::setiosflags (std::ios::fixed) <<
   std::setiosflags (std::ios::left) << std::setprecision (2) <<
-  std::setw (14) << (m_lifeTime - Simulator::Now ()).GetSeconds ();
+  std::setw (14) << (m_lifeTime - Simulator::Now ()).As (unit);
   *os << "\t" << m_hops << "\n";
 }
 
@@ -448,7 +448,7 @@
 bool
 RoutingTable::MarkLinkAsUnidirectional (Ipv4Address neighbor, Time blacklistTimeout)
 {
-  NS_LOG_FUNCTION (this << neighbor << blacklistTimeout.GetSeconds ());
+  NS_LOG_FUNCTION (this << neighbor << blacklistTimeout.As (Time::S));
   std::map<Ipv4Address, RoutingTableEntry>::iterator i =
     m_ipv4AddressEntry.find (neighbor);
   if (i == m_ipv4AddressEntry.end ())
@@ -464,7 +464,7 @@
 }
 
 void
-RoutingTable::Print (Ptr<OutputStreamWrapper> stream) const
+RoutingTable::Print (Ptr<OutputStreamWrapper> stream, Time::Unit unit /* = Time::S */) const
 {
   std::map<Ipv4Address, RoutingTableEntry> table = m_ipv4AddressEntry;
   Purge (table);
@@ -473,7 +473,7 @@
   for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i =
          table.begin (); i != table.end (); ++i)
     {
-      i->second.Print (stream);
+      i->second.Print (stream, unit);
     }
   *stream->GetStream () << "\n";
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/aodv/model/aodv-rtable.h ns-3.32/src/aodv/model/aodv-rtable.h
--- ns-3.31/src/aodv/model/aodv-rtable.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/aodv/model/aodv-rtable.h	2020-10-06 15:35:43.000000000 -0700
@@ -341,7 +341,7 @@
    * Print packet to trace file
    * \param stream The output stream
    */
-  void Print (Ptr<OutputStreamWrapper> stream) const;
+  void Print (Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S) const;
 
 private:
   /// Valid Destination Sequence Number flag
@@ -481,7 +481,7 @@
    * Print routing table
    * \param stream the output stream
    */
-  void Print (Ptr<OutputStreamWrapper> stream) const;
+  void Print (Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S) const;
 
 private:
   /// The routing table
